#include "stdafx.h"
#include "jp/ggaf/core/actor/ex/GgafActorDepository.h"

#include "jp/ggaf/core/util/GgafStatus.h"

using namespace GgafCore;

GgafActorDepository::GgafActorDepository(const char* prm_name, GgafStatus* prm_pStat) : GgafDummyActor(prm_name, prm_pStat) {
    _obj_class |= Obj_GgafActorDepository;
    _class_name = "GgafActorDepository";
    setHitAble(false);
}

void GgafActorDepository::addSubLast(GgafActor* prm_pSub) {

    if (_pSubFirst == nullptr) {
        //ʂp
        _pStatus->set(STAT_DEFAULT_ACTOR_KIND, prm_pSub->_pStatus->getUint(STAT_DEFAULT_ACTOR_KIND));
    } else {
#ifdef MY_DEBUG
        if (_pStatus->getUint(STAT_DEFAULT_ACTOR_KIND) != prm_pSub->_pStatus->getUint(STAT_DEFAULT_ACTOR_KIND)) {
            throwGgafCriticalException("GgafActorDepository::addSubLast قȂʂ̃AN^[o^悤ƂĂ܂B \n"<<
                                       "z="<<_pStatus->getUint(STAT_DEFAULT_ACTOR_KIND)<<"[_pSubFirst="<<_pSubFirst->getName()<<"] \n"<<
                                       "="<<prm_pSub->_pStatus->getUint(STAT_DEFAULT_ACTOR_KIND)<<"["<<prm_pSub->getName()<<"]");
        }
#endif
    }
    prm_pSub->_pDependenceDepository = this;
    prm_pSub->inactivateImmed(); //񊈓
    GgafDummyActor::addSubLast(prm_pSub);
//    _listDispatched.addNext(nullptr);
}

void GgafActorDepository::onReset() {
    _TRACE_("GgafActorDepository::onReset() ["<<getName()<<"]");
    if (_pSubFirst == nullptr) {
        return;
    }
    GgafActor* pActor = getSubFirst();
    while (true) {
        if (pActor->isActive()) {
            //TODO:EEEƔY݂ǂ
            pActor->_on_change_to_inactive_flg = true;
            pActor->onInactive();
            pActor->_frame_of_life_when_inactivation = 0;
            pActor->_will_inactivate_after_flg = false;
        }
        pActor->inactivateImmed();
        if (pActor->isLast()) {
            break;
        } else {
            pActor = pActor->getNext();
            continue;
        }
    }
}
void GgafActorDepository::end(frame prm_offset_frames) {
    frame end_frame_delay = prm_offset_frames + (_sub_num*2) + 1; //o[ɏx点B
    if (_will_end_after_flg) {
        //end()sς݂̏ꍇA葁end()ȂΗLƂ
        if (_frame_of_life_when_end < _frame_of_life + end_frame_delay + GGAF_END_DELAY) {
            //w̕xt[wł邽ߖB
            return;
        }
    }
    _will_end_after_flg = true;
    _frame_of_life_when_end = _frame_of_life + end_frame_delay + GGAF_END_DELAY;
    inactivateDelay(prm_offset_frames); //wt[ɂinactivateŝ͓

    if (_pSubFirst) {
        GgafActor* pElementTemp = _pSubFirst;
        while(true) {
            end_frame_delay -= 2;
            pElementTemp->end(end_frame_delay);
            if (pElementTemp->_is_last_flg) {
                break;
            } else {
                pElementTemp = pElementTemp->_pNext;
            }
        }
    }
}


//œKā
//TODO:GgafActorDepositorýAGgafGroupHeadpāA
//ʂGgafGroupHeadƂɂ΃AN^[̐点̂ł͂Ȃ
//ꍇɂ肯肩AƂōlB
